/*
 * SPI.c
 *
 * Created: 24.04.2014 13:08:38
 *  Author: Piepe
 */ 

#include "SPI.h"

// send one byte

uint8_t SPI_Transfer(uint8_t datax)
{

	uint8_t rdata = 0;

	SpibRegs.SPITXBUF = datax << 8;
    while( ! SpibRegs.SPISTS.bit.INT_FLAG) {} // Wait until data received
	rdata = SpibRegs.SPIRXBUF; // Master reads data

	return rdata;
}

// send four bytes as command
void SPI_Send( uint8_t  wrorrd ,uint8_t chipnr,uint8_t addr,uint8_t command)
{
	SPI_Transfer(wrorrd);
	SPI_Transfer(chipnr);
	SPI_Transfer(addr);
	SPI_Transfer(command);
}

// send Burst
// liest spg + temp fr einen lt6804 (chipnr)
void SPI_SendBurst(uint8_t  wrorrd_1, uint8_t chipnr_1, uint8_t  command_1, uint8_t* sendV, uint8_t* receiveV, uint8_t* sendT, uint8_t* receiveT)
{
	uint8_t i=0;
	uint8_t j=0;

	SPI_Transfer(wrorrd_1);  //choice whether to write or read
	SPI_Transfer(chipnr_1);  // choice of chip number
	SPI_Transfer(command_1); // choice kind of command

	for(i=0;i<12;i++)
	{
		*receiveV=SPI_Transfer(*sendV++);	 // send 12 bytes and receive 12
		*receiveV++;						 // bytes at the same time
	}

	for(j=0;j<2;j++)
	{
		*receiveT=SPI_Transfer(*sendT++);
		*receiveT++;
	}

}

void spi_write(uint8_t  data)  // Byte to be written to SPI port
{

	uint8_t rdata = 0; //drinn lassen um Register zu leeren, hat ansonsten hier keine Bedeutung

	SpibRegs.SPITXBUF = data << 8;
    while( ! SpibRegs.SPISTS.bit.INT_FLAG) {} // Wait until data received
	rdata = SpibRegs.SPIRXBUF; // Master reads data

}

uint8_t spi_read(uint8_t  data) //!The data byte to be written
{
	uint8_t rdata = 0;

	SpibRegs.SPITXBUF = 0xF0f0;
    while( ! SpibRegs.SPISTS.bit.INT_FLAG) {} // Wait until data received
	rdata = SpibRegs.SPIRXBUF; // Master reads data

	return rdata;                //! 3) Return the data read
}
