

#include "main.h"// hier stehen alle weitern includes

int main(void)
{

	#ifdef FLASH
		memcpy(&RamfuncsRunStart,&RamfuncsLoadStart,
				(unsigned long)(&RamfuncsLoadEnd-&RamfuncsLoadStart)+1);
		InitFlash();
	#endif

	InitSysCtrl();	 	// Basic Core Initialization

    EALLOW;
    SysCtrlRegs.WDCR= 0x0068;
    EDIS;

	Gpio_Settings(); // Settings of all GPIO functions ( DIR, MUX,... )

	SPIset();

	GpioDataRegs.GPASET.bit.GPIO27 = 0x1; //set as output // Gelbe LED

	while(1)
	{

		 DELAY_US(500); // 500 ms, nur fr Testzwecke erstmal

		 GpioDataRegs.GPATOGGLE.bit.GPIO27 = 0x1; // Toggle vom der gelben LED

	}

}



void Gpio_Settings(void)
{
	EALLOW;
	//erstmal alle auf vordefinierte Werte setzten

	GpioCtrlRegs.GPAMUX1.all = 0x0;	// GPIO15 ... GPIO0 = General Puropse I/O
	GpioCtrlRegs.GPAMUX2.all = 0x0;	// GPIO31 ... GPIO16 = General Purpose I/O
	GpioCtrlRegs.GPBMUX1.all = 0x0;	// GPIO44 ... GPIO32 = General Purpose I/O
	GpioCtrlRegs.GPBMUX2.all = 0x0;	// GPIO58 ... GPIO50 = General Purpose I/O

	//SPI
	GpioCtrlRegs.GPAMUX1.bit.GPIO13 = 0x3; //set GPIO13 as MISO
	GpioCtrlRegs.GPAMUX1.bit.GPIO14 = 0x3; //set GPIO14 as CLK
	GpioCtrlRegs.GPAMUX1.bit.GPIO15 = 0x3; //set GPIO15 as CS
	GpioCtrlRegs.GPAMUX2.bit.GPIO24 = 0x3; //set GPIO24 as MOSI


	GpioCtrlRegs.GPADIR.bit.GPIO10 = 0x1; //set as output // Rote LED
	GpioCtrlRegs.GPADIR.bit.GPIO27 = 0x1; //set as output // Gelbe LED
	GpioCtrlRegs.GPADIR.bit.GPIO26 = 0x1; //set as output // Grne LED

	GpioCtrlRegs.GPADIR.bit.GPIO28 = 0x1; //set as output // Safety

	//
	GpioCtrlRegs.GPAQSEL1.bit.GPIO13 = 0x3; // set GPIO13 as Asynchronous
	GpioCtrlRegs.GPAQSEL1.bit.GPIO14 = 0x3; // set GPIO14 as Asynchronous
	GpioCtrlRegs.GPAQSEL1.bit.GPIO15 = 0x3; // set GPIO15 as Asynchronous
	GpioCtrlRegs.GPAQSEL2.bit.GPIO24 = 0x3; // set GPIO24 as Asynchronous
	GpioCtrlRegs.GPAQSEL1.bit.GPIO12 = 0x3; // set GPIO12 as Asynchronous

	GpioCtrlRegs.GPAMUX2.bit.GPIO30 = 0x1; // CAN RX
	GpioCtrlRegs.GPAMUX2.bit.GPIO31 = 0x1; // CAN TX


	//EDIS;
}

void SPIset(void)
{
	SpibRegs.SPICCR.bit.SPISWRESET = 0x0; //enable reset state to initialize
	SpibRegs.SPICCR.bit.CLKPOLARITY = 0x1; //Falling Edge without delay---> siehe SPICCR.6
	SpibRegs.SPICTL.bit.CLK_PHASE = 0x0; //clock phase ----> siehe SPICTL.3
	//SpibRegs.SPICTL.bit.SPIINTENA = 0x1; //enable SPI interrupts
	SpibRegs.SPICTL.bit.MASTER_SLAVE = 0x1; //set as master
	SpibRegs.SPICTL.bit.TALK = 0x1; // enables transmission
	SpibRegs.SPIBRR = 0x8; //set baud rate to 1MHZ, SysCtrlRegs.LOSPCP.all = 0x0005 = 9Mhz !!
	SpibRegs.SPICCR.bit.SPICHAR = 7;  //data word lenght 8bit
	//SpibRegs.SPIFFTX.bit.SPIRST = 0x0; //reset rx and tx channels
	//SpibRegs.SPIFFTX.bit.SPIRST = 0x1; //rx and tx ready
	SpibRegs.SPICCR.bit.SPISWRESET = 0x1; //disable reset state
}

void send_can(int MB_Nr,int Byte0,int Byte1,int Byte2,int Byte3, int Byte4, int Byte5, int Byte6, int Byte7)
{
	switch(MB_Nr)
	{
	case 0:
	{
		ECanaMboxes.MBOX0.MDH.all = 0x0;
		ECanaMboxes.MBOX0.MDL.all = 0x0;

		ECanaMboxes.MBOX0.MDL.byte.BYTE0 = Byte0;
		ECanaMboxes.MBOX0.MDL.byte.BYTE1 = Byte1;
		ECanaMboxes.MBOX0.MDL.byte.BYTE2 = Byte2;
		ECanaMboxes.MBOX0.MDL.byte.BYTE3 = Byte3;

		ECanaMboxes.MBOX0.MDH.byte.BYTE4 = Byte4;
		ECanaMboxes.MBOX0.MDH.byte.BYTE5 = Byte5;
		ECanaMboxes.MBOX0.MDH.byte.BYTE6 = Byte6;
		ECanaMboxes.MBOX0.MDH.byte.BYTE7 = Byte7;

		ECanaShadow.CANTRS.all = 0x0;
		ECanaShadow.CANTRS.bit.TRS0 = 1;
		ECanaRegs.CANTRS.all = ECanaShadow.CANTRS.all;
		do
		{
		}while(ECanaRegs.CANTA.bit.TA0 == 0);

		do
		{
		}while(ECanaRegs.CANTRS.bit.TRS0 == 1);

	}break;

	case 1:
	{
		ECanaMboxes.MBOX1.MDH.all = 0x0;
		ECanaMboxes.MBOX1.MDL.all = 0x0;

		ECanaMboxes.MBOX1.MDL.byte.BYTE0 = Byte0;
		ECanaMboxes.MBOX1.MDL.byte.BYTE1 = Byte1;
		ECanaMboxes.MBOX1.MDL.byte.BYTE2 = Byte2;
		ECanaMboxes.MBOX1.MDL.byte.BYTE3 = Byte3;

		ECanaMboxes.MBOX1.MDH.byte.BYTE4 = Byte4;
		ECanaMboxes.MBOX1.MDH.byte.BYTE5 = Byte5;
		ECanaMboxes.MBOX1.MDH.byte.BYTE6 = Byte6;
		ECanaMboxes.MBOX1.MDH.byte.BYTE7 = Byte7;

		ECanaShadow.CANTRS.all = 0x0;
		ECanaShadow.CANTRS.bit.TRS1 = 1;
		ECanaRegs.CANTRS.all = ECanaShadow.CANTRS.all;
		do
		{
		}while(ECanaRegs.CANTA.bit.TA1 == 0);

		do
		{
		}while(ECanaRegs.CANTRS.bit.TRS1 == 1);
	}break;

	case 2:
	{
		ECanaMboxes.MBOX2.MDH.all = 0x0;
		ECanaMboxes.MBOX2.MDL.all = 0x0;

		ECanaMboxes.MBOX2.MDL.byte.BYTE0 = Byte0;
		ECanaMboxes.MBOX2.MDL.byte.BYTE1 = Byte1;
		ECanaMboxes.MBOX2.MDL.byte.BYTE2 = Byte2;
		ECanaMboxes.MBOX2.MDL.byte.BYTE3 = Byte3;

		ECanaMboxes.MBOX2.MDH.byte.BYTE4 = Byte4;
		ECanaMboxes.MBOX2.MDH.byte.BYTE5 = Byte5;
		ECanaMboxes.MBOX2.MDH.byte.BYTE6 = Byte6;
		ECanaMboxes.MBOX2.MDH.byte.BYTE7 = Byte7;

		ECanaShadow.CANTRS.all = 0x0;
		ECanaShadow.CANTRS.bit.TRS2 = 1;
		ECanaRegs.CANTRS.all = ECanaShadow.CANTRS.all;
		do
		{
		}while(ECanaRegs.CANTA.bit.TA2 == 0);

		do
		{
		}while(ECanaRegs.CANTRS.bit.TRS2 == 1);
	}break;

	case 3:
	{
		ECanaMboxes.MBOX3.MDH.all = 0x0;
		ECanaMboxes.MBOX3.MDL.all = 0x0;

		ECanaMboxes.MBOX3.MDL.byte.BYTE0 = Byte0;
		ECanaMboxes.MBOX3.MDL.byte.BYTE1 = Byte1;
		ECanaMboxes.MBOX3.MDL.byte.BYTE2 = Byte2;
		ECanaMboxes.MBOX3.MDL.byte.BYTE3 = Byte3;

		ECanaMboxes.MBOX3.MDH.byte.BYTE4 = Byte4;
		ECanaMboxes.MBOX3.MDH.byte.BYTE5 = Byte5;
		ECanaMboxes.MBOX3.MDH.byte.BYTE6 = Byte6;
		ECanaMboxes.MBOX3.MDH.byte.BYTE7 = Byte7;

		ECanaShadow.CANTRS.all = 0x0;
		ECanaShadow.CANTRS.bit.TRS3 = 1;
		ECanaRegs.CANTRS.all = ECanaShadow.CANTRS.all;
		do
		{
		}while(ECanaRegs.CANTA.bit.TA3 == 0);

		do
		{
		}while(ECanaRegs.CANTRS.bit.TRS3 == 1);

	}break;

	case 4:
	{
		ECanaMboxes.MBOX4.MDH.all = 0x0;
		ECanaMboxes.MBOX4.MDL.all = 0x0;

		ECanaMboxes.MBOX4.MDL.byte.BYTE0 = Byte0;
		ECanaMboxes.MBOX4.MDL.byte.BYTE1 = Byte1;
		ECanaMboxes.MBOX4.MDL.byte.BYTE2 = Byte2;
		ECanaMboxes.MBOX4.MDL.byte.BYTE3 = Byte3;

		ECanaMboxes.MBOX4.MDH.byte.BYTE4 = Byte4;
		ECanaMboxes.MBOX4.MDH.byte.BYTE5 = Byte5;
		ECanaMboxes.MBOX4.MDH.byte.BYTE6 = Byte6;
		ECanaMboxes.MBOX4.MDH.byte.BYTE7 = Byte7;

		ECanaShadow.CANTRS.all = 0x0;
		ECanaShadow.CANTRS.bit.TRS4 = 1;
		ECanaRegs.CANTRS.all = ECanaShadow.CANTRS.all;
		do
		{
		}while(ECanaRegs.CANTA.bit.TA4 == 0);

		do
		{
		}while(ECanaRegs.CANTRS.bit.TRS4 == 1);

	}break;

	case 5:
	{
		ECanaMboxes.MBOX5.MDH.all = 0x0;
		ECanaMboxes.MBOX5.MDL.all = 0x0;

		ECanaMboxes.MBOX5.MDL.byte.BYTE0 = Byte0;
		ECanaMboxes.MBOX5.MDL.byte.BYTE1 = Byte1;
		ECanaMboxes.MBOX5.MDL.byte.BYTE2 = Byte2;
		ECanaMboxes.MBOX5.MDL.byte.BYTE3 = Byte3;

		ECanaMboxes.MBOX5.MDH.byte.BYTE4 = Byte4;
		ECanaMboxes.MBOX5.MDH.byte.BYTE5 = Byte5;
		ECanaMboxes.MBOX5.MDH.byte.BYTE6 = Byte6;
		ECanaMboxes.MBOX5.MDH.byte.BYTE7 = Byte7;

		ECanaShadow.CANTRS.all = 0x0;
		ECanaShadow.CANTRS.bit.TRS5 = 1;
		ECanaRegs.CANTRS.all = ECanaShadow.CANTRS.all;
		do
		{
		}while(ECanaRegs.CANTA.bit.TA5 == 0);

		do
		{
		}while(ECanaRegs.CANTRS.bit.TRS5 == 1);


	}break;

	case 6:
	{
		ECanaMboxes.MBOX6.MDH.all = 0x0;
		ECanaMboxes.MBOX6.MDL.all = 0x0;

		ECanaMboxes.MBOX6.MDL.byte.BYTE0 = Byte0;
		ECanaMboxes.MBOX6.MDL.byte.BYTE1 = Byte1;
		ECanaMboxes.MBOX6.MDL.byte.BYTE2 = Byte2;
		ECanaMboxes.MBOX6.MDL.byte.BYTE3 = Byte3;

		ECanaMboxes.MBOX6.MDH.byte.BYTE4 = Byte4;
		ECanaMboxes.MBOX6.MDH.byte.BYTE5 = Byte5;
		ECanaMboxes.MBOX6.MDH.byte.BYTE6 = Byte6;
		ECanaMboxes.MBOX6.MDH.byte.BYTE7 = Byte7;

		ECanaShadow.CANTRS.all = 0x0;
		ECanaShadow.CANTRS.bit.TRS6 = 1;
		ECanaRegs.CANTRS.all = ECanaShadow.CANTRS.all;
		do
		{
		}while(ECanaRegs.CANTA.bit.TA6 == 0);

		do
		{
		}while(ECanaRegs.CANTRS.bit.TRS6 == 1);
	}break;

	case 7:
	{
		ECanaMboxes.MBOX7.MDH.all = 0x0;
		ECanaMboxes.MBOX7.MDL.all = 0x0;

		ECanaMboxes.MBOX7.MDL.byte.BYTE0 = Byte0;
		ECanaMboxes.MBOX7.MDL.byte.BYTE1 = Byte1;
		ECanaMboxes.MBOX7.MDL.byte.BYTE2 = Byte2;
		ECanaMboxes.MBOX7.MDL.byte.BYTE3 = Byte3;

		ECanaMboxes.MBOX7.MDH.byte.BYTE4 = Byte4;
		ECanaMboxes.MBOX7.MDH.byte.BYTE5 = Byte5;
		ECanaMboxes.MBOX7.MDH.byte.BYTE6 = Byte6;
		ECanaMboxes.MBOX7.MDH.byte.BYTE7 = Byte7;

		ECanaShadow.CANTRS.all = 0x0;
		ECanaShadow.CANTRS.bit.TRS7 = 1;
		ECanaRegs.CANTRS.all = ECanaShadow.CANTRS.all;
		do
		{
		}while(ECanaRegs.CANTA.bit.TA7 == 0);
	}break;

	}

}

void can_init_bms(void)
{
	ECanaRegs.CANME.all = 0x0;

	ECanaMboxes.MBOX1.MSGID.all = 0x0;
	ECanaMboxes.MBOX2.MSGID.all = 0x0;
	ECanaMboxes.MBOX3.MSGID.all = 0x0;
	ECanaMboxes.MBOX4.MSGID.all = 0x0;
	ECanaMboxes.MBOX5.MSGID.all = 0x0;

    ECanaMboxes.MBOX1.MSGID.bit.STDMSGID = 0x791; // Sende Message ID //Stack 1
    ECanaMboxes.MBOX2.MSGID.bit.STDMSGID = 0x792; // Sende Message ID //Stack 2
    ECanaMboxes.MBOX3.MSGID.bit.STDMSGID = 0x793; // Sende Message ID //Stack 3
    ECanaMboxes.MBOX4.MSGID.bit.STDMSGID = 0x794; // Sende Message ID //Stack 4
    ECanaMboxes.MBOX5.MSGID.bit.STDMSGID = 0x795; // Sende Message ID //Stack 4
    ECanaMboxes.MBOX6.MSGID.bit.STDMSGID = 0x796; // Sende Message ID //Stack 6

    //Mailbox enable
    ECanaShadow.CANME.all = ECanaRegs.CANME.all;
    ECanaShadow.CANME.bit.ME1 = 1 ;
    ECanaShadow.CANME.bit.ME2 = 1 ;
    ECanaShadow.CANME.bit.ME3 = 1 ;
    ECanaShadow.CANME.bit.ME4 = 1 ;
    ECanaShadow.CANME.bit.ME5 = 1 ;
    ECanaShadow.CANME.bit.ME6 = 1 ;
    ECanaRegs.CANME.all = ECanaShadow.CANME.all;

    // Mailbox direction
    ECanaShadow.CANMD.all = ECanaRegs.CANMD.all;
    ECanaShadow.CANMD.bit.MD1 = 0 ; // MB 1 als Sende MB
    ECanaShadow.CANMD.bit.MD2 = 0 ; // MB 1 als Sende MB
    ECanaShadow.CANMD.bit.MD3 = 0 ; // MB 1 als Sende MB
    ECanaShadow.CANMD.bit.MD4 = 0 ; // MB 1 als Sende MB
    ECanaShadow.CANMD.bit.MD5 = 0 ; // MB 1 als Sende MB
    ECanaShadow.CANMD.bit.MD6 = 0 ; // MB 1 als Sende MB
    ECanaRegs.CANMD.all = ECanaShadow.CANMD.all;

    // Mailbox 5 Settings RTR=0 und DLC 8 bit
    ECanaMboxes.MBOX1.MSGCTRL.all = 0xF;
    ECanaMboxes.MBOX2.MSGCTRL.all = 0xF;
    ECanaMboxes.MBOX3.MSGCTRL.all = 0xF;
    ECanaMboxes.MBOX4.MSGCTRL.all = 0xF;
    ECanaMboxes.MBOX5.MSGCTRL.all = 0xF;
    ECanaMboxes.MBOX6.MSGCTRL.all = 0xF;
}

void LED (char LED)
{

	if (LED == 'g')
	{
		GpioDataRegs.GPASET.bit.GPIO26 = 0x1;
		GpioDataRegs.GPACLEAR.bit.GPIO27 = 0x1;
		GpioDataRegs.GPACLEAR.bit.GPIO10 = 0x1;
	}

	if (LED == 'y')
	{
		GpioDataRegs.GPASET.bit.GPIO27 = 0x1;
		GpioDataRegs.GPACLEAR.bit.GPIO26 = 0x1;
		GpioDataRegs.GPACLEAR.bit.GPIO10 = 0x1;
	}

	if (LED == 'r')
	{
		GpioDataRegs.GPASET.bit.GPIO10 = 0x1;
		GpioDataRegs.GPACLEAR.bit.GPIO27 = 0x1;
		GpioDataRegs.GPACLEAR.bit.GPIO26 = 0x1;
	}
};

void Relais (uint8_t an)
{
	if(an == 1)
	{
		GpioDataRegs.GPASET.bit.GPIO28 = 0x1;
	}
	else
	{
		GpioDataRegs.GPACLEAR.bit.GPIO28 = 0x1;
	}
};


